/* 

passlogd - passive syslog capture daemon
copyright (c) 2001 - christian void <cvoid@morphine.com>

file: parse.c

history: 

04jun01 cvoid: created.

*/

#include "passlog.h"

/* globals */
extern int debug;
extern int vflag;
extern int sflag;
extern int rflag;
extern int fflag;
extern int logfd;

/* pcap callback routine for parsing packets */
/* warning: this definately needs to be rewritten */

void sl_parse(char *user, struct pcap_pkthdr *pkthdr, u_char *pkt)
{
  int i, j, wb;
  char *timestr;
  time_t curtime;
  int err = 0;
  char *errstr;
  char srcip[255];
  char dstip[255];
  char level[5];
  char message[255];
  char buffer[1024];
  int  syslev;

  /* initialize our buffers - this just has to be expensive as fuck */
  init_buf(srcip, sizeof(srcip));
  init_buf(dstip, sizeof(dstip));
  init_buf(level, sizeof(level));
  init_buf(message, sizeof(message));
  init_buf(buffer, sizeof(buffer));
  
  i = 26;
  
  if (pkthdr->caplen > 32)
    {
      sprintf(srcip, "%d.%d.%d.%d", pkt[i], pkt[i+1], pkt[i+2], pkt[i+3]);
      i=i+4;
      sprintf(dstip, "%d.%d.%d.%d", pkt[i], pkt[i+1], pkt[i+2], pkt[i+3]);
      i=i+4;
    }
  else
    {
      printf("packet too short!\n");
      return;
    }
  
  i=i+9;
  j=0;
  
  while(pkt[i] != '>'){
    level[j] = pkt[i];
    i++;
    j++;
  }
  i++;
  


  memcpy(message, &pkt[i], pkthdr->caplen - i);

  if(rflag){
    /* reverse lookup the ip addresses */
    err = reverse_lookup(srcip);
    if(debug)printf("reverse: %d\n", err);
    reverse_lookup(dstip);
    if(debug)printf("reverse: %d\n", err);
  }

  /* built the logstring */
  sprintf(buffer, "%s to %s: <%s> %s", srcip, dstip, level, message);

  if(sflag){
    /* log to syslog */
    /* break out facility and priority  */
    syslev = atoi(level);
    openlog("passlogd", 0, LOG_DAEMON);
    syslog(syslev, "%s", buffer);
    closelog();
  }
  
  if(fflag){
    /* dump to stdio with much verbosity */
    err = gettimeofday((void *) &curtime, NULL);
    timestr = ctime(&curtime);

    timestr[strlen(timestr)-1]=0x20;

    /* log to logfile */
    wb = write(logfd, timestr, strlen(timestr));
    wb = write(logfd, buffer, strlen(buffer));

    if(debug){
      errstr = (char *) strerror(errno);
      printf("wrote %d bytes to logfile\n", wb);
      printf("write() returned: %s\n", errstr);
    }

  }
}
